##	Copyright (c) 2004 The Regents of the University of California. All Rights
##	Reserved. Permission to use, copy, modify, and distribute this  software
##	and its documentation for educational, research and non-profit purposes,
##	without fee, and without a written agreement is hereby granted, provided
##	that the above copyright notice, this paragraph and the following two
##	paragraphs appear in all copies. This software program and documentation
##	are copyrighted  by The Regents of the University of California ("The
##	University of California").
##
##	THE SOFTWARE PROGRAM AND DOCUMENTATION ARE SUPPLIED "AS IS," WITHOUT ANY
##	ACCOMPANYING SERVICES FROM THE UNIVERSITY OF CALFORNIA. FURTHERMORE, THE
##	UNIVERSITY OF CALIFORNIA DOES NOT WARRANT THAT THE OPERATION OF THE
##	PROGRAM  WILL BE UNINTERRUPTED OR ERROR-FREE. THE END-USER UNDERSTANDS
##	THAT THE PROGRAM  WAS DEVELOPED FOR RESEARCH PURPOSES AND IS ADVISED NOT
##	TO RELY EXCLUSIVELY  ON THE PROGRAM FOR ANY REASON.
##
##	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
##	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
##	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
##	DOCUMENTATION,  EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
##	THE POSSIBILITY OF SUCH DAMAGES. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY
##	DISCLAIMS ANY  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
##	WARRANTIES OF  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
##	SOFTWARE PROVIDED  HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
##	CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
##	ENHANCEMENTS, OR  MODIFICATIONS.

from	Tkinter import *
import	my_tkDialog
import	tkMessageBox

cfg = 'scale.cfg'

def	read(parent):
	try:
		for l in open(cfg).readlines(): exec l

		parent.v_bottom = v_bottom
		parent.v_top = v_top

		parent.v_min = v_min
		parent.v_max = v_max

		parent.c_bottom = c_bottom
		parent.c_top = c_top

		parent.c_min = c_min
		parent.c_max = c_max

		parent.t_left = t_left
		parent.t_right = t_right
		
		parent.t_min = t_min
		parent.t_max = t_max

	except:
		parent.v_bottom = 3.7
		parent.v_top = 4.2

		parent.v_min = 0.
		parent.v_max = 5.

		parent.c_bottom = 0.
		parent.c_top = 0.5

		parent.c_min = 0.
		parent.c_max = 1.

		parent.t_left = 0.
		parent.t_right = 60.
		
		parent.t_min = 0.
		parent.t_max = 1200.

		write(parent)


def	write(parent):
	f = open(cfg, 'w')

	print >> f, 'v_bottom =', parent.v_bottom
	print >> f, 'v_top =', parent.v_top

	print >> f, 'v_min =', parent.v_min
	print >> f, 'v_max =', parent.v_max

	print >> f, 'c_bottom =', parent.c_bottom
	print >> f, 'c_top =', parent.c_top

	print >> f, 'c_min =', parent.c_min
	print >> f, 'c_max =', parent.c_max

	print >> f, 't_left =', parent.t_left
	print >> f, 't_right =', parent.t_right

	print >> f, 't_min =', parent.t_min
	print >> f, 't_max =', parent.t_max

	f.close()


class	scl_dlg(my_tkDialog.Dialog):
	def	__init__(self, parent, vars = None):
		if vars != None:
			self.v_bottom, self.v_top, self.v_min, self.v_max, \
			self.c_bottom, self.c_top, self.c_min, self.c_max, \
			self.t_left, self.t_right, self.t_min, self.t_max \
			= vars
		else:
			self.v_bottom = parent.v_bottom
			self.v_top = parent.v_top

			self.v_min = parent.v_min
			self.v_max = parent.v_max

			self.c_bottom = parent.c_bottom
			self.c_top = parent.c_top

			self.c_min = parent.c_min
			self.c_max = parent.c_max

			self.t_left = parent.t_left
			self.t_right = parent.t_right

			self.t_min = parent.t_min
			self.t_max = parent.t_max

		my_tkDialog.Dialog.__init__(self, parent, title = 'Chart Scale', wait_for_close = 0)


	def	body(self, master):
		Label(master, text = 'v_bottom:').grid(row = 0, sticky = W)
		self.e11 = Entry(master)
		Label(master, text = 'v_top:').grid(row = 0, column = 2, sticky = W)
		self.e12 = Entry(master)

		self.e11.grid(row = 0, column = 1)
		self.e12.grid(row = 0, column = 3)

		Label(master, text = 'v_min:').grid(row = 1, sticky = W)
		self.e13 = Entry(master)
		Label(master, text = 'v_max:').grid(row = 1, column = 2, sticky = W)
		self.e14 = Entry(master)

		self.e13.grid(row = 1, column = 1)
		self.e14.grid(row = 1, column = 3)


		Label(master, text = '').grid(row = 2, sticky = W)
		Label(master, text = 'c_bottom:').grid(row = 3, sticky = W)
		self.e21 = Entry(master)
		Label(master, text = 'c_top:').grid(row = 3, column = 2, sticky = W)
		self.e22 = Entry(master)

		self.e21.grid(row = 3, column = 1)
		self.e22.grid(row = 3, column = 3)

		Label(master, text = 'c_min:').grid(row = 4, sticky = W)
		self.e23 = Entry(master)
		Label(master, text = 'c_max:').grid(row = 4, column = 2, sticky = W)
		self.e24 = Entry(master)

		self.e23.grid(row = 4, column = 1)
		self.e24.grid(row = 4, column = 3)


		Label(master, text = '').grid(row = 5, sticky = W)
		Label(master, text = 't_left:').grid(row = 6, sticky = W)
		self.e31 = Entry(master)
		Label(master, text = 't_right:').grid(row = 6, column = 2, sticky = W)
		self.e32 = Entry(master)

		self.e31.grid(row = 6, column = 1)
		self.e32.grid(row = 6, column = 3)

		Label(master, text = 't_min:').grid(row = 7, sticky = W)
		self.e33 = Entry(master)
		Label(master, text = 't_max:').grid(row = 7, column = 2, sticky = W)
		self.e34 = Entry(master)

		self.e33.grid(row = 7, column = 1)
		self.e34.grid(row = 7, column = 3)


		self.e11.insert(0, str(self.v_bottom))
		self.e12.insert(0, str(self.v_top))
		self.e13.insert(0, str(self.v_min))
		self.e14.insert(0, str(self.v_max))

		self.e21.insert(0, str(self.c_bottom))
		self.e22.insert(0, str(self.c_top))
		self.e23.insert(0, str(self.c_min))
		self.e24.insert(0, str(self.c_max))

		self.e31.insert(0, str(self.t_left))
		self.e32.insert(0, str(self.t_right))
		self.e33.insert(0, str(self.t_min))
		self.e34.insert(0, str(self.t_max))
		

	def	validate(self):
		try:
			v_bottom = float(self.e11.get())
			v_top = float(self.e12.get())
			v_min = float(self.e13.get())
			v_max = float(self.e14.get())

			c_bottom = float(self.e21.get())
			c_top = float(self.e22.get())
			c_min = float(self.e23.get())
			c_max = float(self.e24.get())

			t_left = float(self.e31.get())
			t_right = float(self.e32.get())
			t_min = float(self.e33.get())
			t_max = float(self.e34.get())
		except:
			tkMessageBox.showwarning('Bad input', 'Illegal numerical values')
			return 0

		cond = [
			'v_min > v_bottom',
			'v_bottom >= v_top',
			'v_top > v_max',

			'c_min > c_bottom',
			'c_bottom >= c_top',
			'c_top > c_max',

			't_min > t_left',
			't_left >= t_right',
			't_right > t_max',
			]

		for c in cond:
			if eval(c):
				tkMessageBox.showwarning('Bad input', c)
				return 0
			

		self.v_bottom = v_bottom
		self.v_top = v_top
		self.v_min = v_min
		self.v_max = v_max
		
		self.c_bottom = c_bottom
		self.c_top = c_top
		self.c_min = c_min
		self.c_max = c_max

		self.t_left = t_left
		self.t_right = t_right
		self.t_min = t_min
		self.t_max = t_max

		return 1


	def	apply(self):
		self.parent.setWait()
		
		self.t_left, self.v_bottom, self.t_right, self.v_top = self.parent.v_chart.resetScale(
			(self.t_left, self.v_bottom, self.t_right, self.v_top),
			(self.t_min, self.v_min, self.t_max, self.v_max)
			)
		self.t_min, self.t_max = self.parent.v_chart.x_min, self.parent.v_chart.x_max
		self.v_min, self.v_max = self.parent.v_chart.y_min, self.parent.v_chart.y_max
		
		self.t_left, self.c_bottom, self.t_right, self.c_top = self.parent.c_chart.resetScale(
			(self.t_left, self.c_bottom, self.t_right, self.c_top),
			(self.t_min, self.c_min, self.t_max, self.c_max)
			)
		self.t_min, self.t_max = self.parent.c_chart.x_min, self.parent.c_chart.x_max
		self.c_min, self.c_max = self.parent.c_chart.y_min, self.parent.c_chart.y_max
		
		self.parent.clearWait()		

		self.e11.delete(0, END)
		self.e11.insert(0, str(self.v_bottom))
		self.e12.delete(0, END)
		self.e12.insert(0, str(self.v_top))
		self.e13.delete(0, END)
		self.e13.insert(0, str(self.v_min))
		self.e14.delete(0, END)
		self.e14.insert(0, str(self.v_max))

		self.e21.delete(0, END)
		self.e21.insert(0, str(self.c_bottom))
		self.e22.delete(0, END)
		self.e22.insert(0, str(self.c_top))
		self.e23.delete(0, END)
		self.e23.insert(0, str(self.c_min))
		self.e24.delete(0, END)
		self.e24.insert(0, str(self.c_max))

		self.e31.delete(0, END)
		self.e31.insert(0, str(self.t_left))
		self.e32.delete(0, END)
		self.e32.insert(0, str(self.t_right))
		self.e33.delete(0, END)
		self.e33.insert(0, str(self.t_min))
		self.e34.delete(0, END)
		self.e34.insert(0, str(self.t_max))

		self.parent.v_bottom = self.v_bottom
		self.parent.v_top = self.v_top
		self.parent.v_min = self.v_min
		self.parent.v_max = self.v_max
		
		self.parent.c_bottom = self.c_bottom
		self.parent.c_top = self.c_top
		self.parent.c_min = self.c_min
		self.parent.c_max = self.c_max

		self.parent.t_left = self.t_left
		self.parent.t_right = self.t_right
		self.parent.t_min = self.t_min
		self.parent.t_max = self.t_max

		self.update()
						  
		return self.result



if	__name__ == '__main__':
	global	root

	def	test():
		d = scl_dlg(root, (2, 3, 1, 4) * 3)
		print d.result        	

	root = Tk()
	Button(root, text = 'Test', command = test).pack()
	root.mainloop()
